<?php
/**
 * A PHP common file, that gathers all mySQL database and tables creation.
 */

/**
 * Creates the SQL DB if necessary, and then connects to it.
 */
function connect_to_db($database_location, $database_user, $database_password, $database_name)
{
	//global $database;
	$database = mysql_connect($database_location, $database_user, $database_password);
	//mysql_query("CREATE DATABASE $database_name;", $database);
	mysql_select_db($database_name, $database);
	$table_name = get_audit_table_name();
	return $database;
}

/**
 * Creates a SQL table if necessary.
 *
 *@param a database object that has already been initialized
 *@param a table creation query (do not forget to end the query with ";")
 */
function create_table($database, $table_creation_query)
{
	mysql_query("$table_creation_query", $database);
}	

/**
 * @return the name of the SQL table that contains the audit information (how many times a page has been visited)
 */
function get_audit_table_name()
{
	return "audit";
}

/**
 * Creates the authentification table if necessary.
 */
function create_audit_table($database)
{
	$table_name = get_audit_table_name();
	create_table($database, "CREATE TABLE $table_name (ID VARCHAR(100), HIT BIGINT);");
}

/**
 * @return the name of the SQL table that contains the pages authorizations
 */
function get_authorization_table_name()
{
	return "authorization";
}

/**
 * Creates the authorization table if necessary.
 */
function create_authorization_table($database)
{
	$table_name = get_authorization_table_name();
	create_table($database, "CREATE TABLE $table_name (ID VARCHAR(100), LEVEL VARCHAR(10));");
}

/**
 * @return a string that represents the authorization level for the given page
 */
function get_page_authorization_level($database, $page_name)
{
	create_authorization_table($database);
	$table_name = get_authorization_table_name();
	$query_result = mysql_query("SELECT LEVEL FROM $table_name WHERE ID='$page_name';", $database);
	if ($row = mysql_fetch_row($query_result))
	{
		return $row[0];
	}
	else
	{
		mysql_query("INSERT INTO $table_name (ID, LEVEL) VALUES('$page_name', 'public');", $database);
		return "public";
	}
}

/**
 * @return <code>true</code> is the page is not public and requires authentification
 */
function does_page_need_login($database, $page_name)
{
	create_authorization_table($database);
	$table_name = get_authorization_table_name();
	$query_result = mysql_query("SELECT LEVEL FROM $table_name WHERE ID='$page_name';", $database);
	if ($row = mysql_fetch_row($query_result))
	{
		if ($row[0] != "public")
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else
	{
		mysql_query("INSERT INTO $table_name (ID, LEVEL) VALUES('$page_name', 'public');", $database);
		return false;
	}
}

/**
 * @return the name of the SQL table that contains the users login
 */
function get_users_table_name()
{
	return "user";
}

/**
 * Creates the users login table if necessary.
 */
function create_users_table($database)
{
	$table_name = get_users_table_name();
	create_table($database, "CREATE TABLE $table_name (LOGIN VARCHAR(100), LEVEL VARCHAR(10));");
}

/**
 * @return <code>true</code> if the given user is authorized to enter the given page
 */
function is_authorized($database, $page_name, $login)
{
	if (get_page_authorization_level($database, $page_name) == "public")
	{
		return true;
	}
	create_users_table($database);
	$table_name = get_users_table_name();
	$query_result = mysql_query("SELECT LEVEL FROM $table_name WHERE LOGIN='$login';", $database);
	if ($row = mysql_fetch_row($query_result))
	{
		if ($row[0] == "private")
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else
	{
		mysql_query("INSERT INTO $table_name (LOGIN, LEVEL) VALUES('$login', 'public');", $database);
		return false;
	}
}

/**
 * @return the name of the SQL table that contains the authenfication information (who has been registered to browse the site)
 */
function get_authentification_table_name()
{
	return "authentification";
}

/**
 * Creates the authentification table if necessary.
 */
function create_authentification_table($database)
{
	$table_name = get_authentification_table_name();
	create_table($database, "CREATE TABLE $table_name (LOGIN VARCHAR(100), PASSWORD VARCHAR(16));");
}

/**
 * Displays the HTML form that enables to log in.
 */
function attempt_log()
{
	echo("<br/>\n<br/>\n<br/>\n");
	echo("<blockquote>");
	echo("<p><b>");
	echo("You need to login in order to enter that part of the site.</br>");
	echo("</b></p>");
	echo("<table>");
	echo("<form action=\"$PHP_SELF\" method=\"POST\" name=\"login_form\">");
	echo("<tr><td>Login:</td></tr>");
	echo("<tr><td><input type=\"text\" name=\"login\"></td></tr>");
	echo("<tr><td>Password:</td></tr>");
	echo("<tr><td><input type=\"password\" name=\"password\"></td></tr>");
	echo("<tr><td><input type=\"submit\" value=\"Login\"></td></tr>");
	echo("<tr><td>");
	echo("</form>");
	echo("</table>");
	echo("</blockquote>");
	echo("<br/>\n<br/>\n<br/>\n");
}

/**
 * @return <code>true</code> if the given user actually exists and its password is OK
 */
function check_authentification($authentification_database, $login, $password)
{
	$lower_login = strtolower($login);
	$table_name = get_authentification_table_name();
	create_table($authentification_database, "CREATE TABLE $table_name (LOGIN VARCHAR(100), PASSWORD VARCHAR(16));");

	//mysql_query("INSERT INTO $table_name (LOGIN, PASSWORD) VALUES('$login', '$password');", $database);
	$query_result = mysql_query("SELECT LOGIN, PASSWORD FROM $table_name WHERE LOGIN='$lower_login' AND PASSWORD='$password';", $authentification_database);
	if (mysql_fetch_row($query_result))
	{
		return true;
	}
	else
	{
		return false;
	}
}

/**
 * Creates a login form if necessary. If the end-user is already logged-in, nothing is displayed.
 * The next page reached will be the same as the calling one if the login process suceeded.
 *
 * @param authentification_database the database object that contains the authentification table
 * @param login this variable should always provided with the '$login'
 * @param password this variable should always provided with the '$password'
 * @return <ul>
 * <li>-1 if the user failed in authentificating</li>
 * <li>0 if the authentification process has not been performed yet</li>
 * <li>1 if the user has been successfully authentificated</li>
 * </ul>
 */
function login($authentification_database, $login, $password)
{
	if (!isset($login))
	{
		attempt_log();
		return 0;
	}
	else
	{
		if (check_authentification($authentification_database, $login, $password) == true)
		{
			return 1;
		}
		else
		{
			return -1;
		}
	}
}

/**
 * Performs the same thing as the function refered to, but uses the notion of PHP session. The $login and $password variables are
 * remembered. The session must have already been started.
 *
 * @see #login
 */
function login_wih_session($authentification_database, $login, $password)
{
	// Initializes the session variables that remembers if the client has authentified
	if (!isset($_SESSION['authentified']))
	{
		$_SESSION['authentified'] = false;
	}
	if (!isset($_SESSION['attempting_log']))
	{
		$_SESSION['attempting_log'] = false;
	}
	// If the client is already logged-in, perfect
	if ($_SESSION['authentified'] == true)
	{
		return 1;
	}
	// If the end-user is not currently being logged
	if ($_SESSION['attempting_log'] == false)
	{
		attempt_log();
		$_SESSION['attempting_log'] = true;
		return 0;
	}
	else
	{
		if (check_authentification($authentification_database, $login, $password) == true)
		{
			// Remembers the client login
			$_SESSION['login'] = $login;
			$_SESSION['authentified'] = true;
			return 1;
		}
		else
		{
			$_SESSION['attempting_log'] = false;
			return -1;
		}
	}
}

/**
 * Determines whether the previously authentificated end-user is allowed to enter a given part of a web site.
 *
 * @param acl_database_location the server hostname that hosts the ACL database
 * @param acl_database_user the user name of the ACL database
 * @param acl_database_password the user password of the ACL database
 * @param acl_database_name the name of the ACL database
 * @param aco_section the section of the ACO to inspect
 * @param aco the ACO to inspect
 * @param aro_section the section of the ARO to inspect
 * @param aro the ARO to inspect
 * @return <code>true</code> if the end-user is allowed
 */
function acl(/*$acl_database_location, $acl_database_user, $acl_database_password, $acl_database_name, */$aco_section, $aco, $aro_section, $aro)
{
	require_once("gacl.class.php");
	/*$gacl_options = array(
							'db_type' => 'mysql',
							'db_host' => $acl_database_location,
							'db_user' => $acl_database_user,
							'db_password' => $acl_database_password,
							'db_name' => $acl_database_name
						);

	$gacl = new gacl($gacl_options);*/
	$gacl = new gacl();

	if ( $gacl->acl_check($aco_section, $aco, $aro_section, $aro))
	{
		return true;
	}
	else
	{
		return false;
	}
}

/**
 * Tries to login the client once.
 *
 * @return <ul>
 * <li>-2 if the client is sent an authentification form</li>
 * <li>-1 if the user failed in logging-in due to an authentification problem</li>
 * <li>0 if the user is not allowed to access the resource</li>
 * <li>1 if the user succeeded in logging-in</li>
 * @see #login
 * @see #login_wih_session
 * @see #acl
 */
function login_and_acl($authentification_database, $login, $password, $aco_section, $aco, $aro_section)
{
	// No need to login is the page is public
	if (does_page_need_login($authentification_database, $aco) == false)
	{
		return 1;
	}

	//$login_result = login($authentification_database, $login, $password);
	$login_result = login_wih_session($authentification_database, $login, $password);

	if ($login_result == 0)
	{
		return -2;
	}
	if ($login_result == -1)
	{
		// Authentification failed!
		return -1;
	}
	// The client login has been entered and the user is being authentificated
	$login = $_SESSION['login'];
	$result = 1;
	/*$acl_result = acl($aco_section, $aco, $aro_section, $login);
	if ($acl_result == false)
	{
		// User '$login' not allowed to enter the '$aco' page
		$result = 0;
	}*/
	// We test that the page is authorized for the client
	if (is_authorized($authentification_database, $aco, $login) == false)
	{
		$result = 0;
	}
	if ($result == 0)
	{
		echo("<p><blockquote><b color=\"red\">You are not allowed to enter that page!</b></blockquote><p>");
	}
	// User '$login' allowed to enter the '$aco' page
	return $result;
}

/**
 * Tries to login the client, but ad vitam aeternam.
 *
 * @see #login_and_acl
 */
function login_and_acl_ave($authentification_database, $login, $password, $aco_section, $aco, $aro_section)
{
	$login_and_acl_result = login_and_acl($authentification_database, $login, $password, $aco_section, $aco, $aro_section);
	if ($login_and_acl_result == -1)
	{
		attempt_log();
		$_SESSION['attempting_log'] = true;
	}
	return $login_and_acl_result;
}

/**
 * Called in order to indicate that a page has been hit by a client.
 */
function page_hit($database, $page_name)
{
	$table_name = get_audit_table_name();
	$result = mysql_query("SELECT * FROM $table_name WHERE ID='$page_name';", $database);
	if (!$row = mysql_fetch_row($result))
	{
		mysql_query("INSERT INTO $table_name (ID, HIT) VALUES('$page_name', 0);", $database);
		$row = mysql_fetch_row($result);
	}
	$new_value = $row[1] + 1;
	mysql_query("UPDATE $table_name SET HIT=$new_value WHERE ID='$page_name';", $database);
}

/**
 * The same method as the refered one, but this one assumes that PHP session is enabled.
 */
function page_hit_with_session($database, $page_name)
{
	$session_pagename_variable = "session.$page_name";
	if (!isset($_SESSION["$session_pagename_variable"]))
	{
		$_SESSION["$session_pagename_variable"] = $page_name;
		page_hit($database, $page_name);
	}
}

/**
 * Prints the number of times a page has been reached.
 */
function print_page_hit_number($database, $page_name)
{
	$table_name = get_audit_table_name();
	$result = mysql_query("SELECT * FROM $table_name WHERE ID='$page_name';", $database);
	$row = mysql_fetch_row($result);
	printf("%d", $row[1]);
}

/**
 * Prints the current date.
 */
function print_date()
{
	$now_date = getdate();
	$now_time = gettimeofday();
	$now_timestamp = date("Y.m.d G:i:s");
	printf("%s", $now_timestamp);
}

/**
 * Prints the statistics concerning the current web site.
 */
function print_site_statistics($database)
{
	$table_name = get_audit_table_name();
	$result = mysql_query("SELECT * FROM $table_name;", $database);
	echo "<table border=\"1\" width=\"100%\">\n";
	echo "<tr><th>Page</th><th>Hit</th></tr>\n";
	while ($row = mysql_fetch_row($result))
	{
		printf("<tr><td>%s</td><td>%d</td></tr>\n", $row[0], $row[1]);
	}
	echo "</table>\n";
}

?>
